<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>39.50</title>

    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>
<script>
    $(document).on("click","#user-table .detail-btn", function(){
        onDeatailBtnClick(this);
    })
    $(document).ready(function () {
        const gDATA_COLUMN = [
        "id" ,
        "firstname",
        "lastname",
        "country" ,
        "subject" ,
        "customerType" ,
        "registerStatus" ,
        "Action"
        ]
        const gUSER_ID = 0;
        const gFIRST_NAME = 1;
        const gLAST_NAME = 2;
        const gCOUNTRY = 3;
        const gSUBJECT = 4;
        const gCUSTOMER_TYPE = 5;
        const gREGISTER_STATUS = 6;
        const gACTION = 7;

        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var vDataTable = $("#user-table").DataTable({
            columns: [
                { "data":  gDATA_COLUMN[gUSER_ID]},
                { "data":  gDATA_COLUMN[gFIRST_NAME]},
                { "data":  gDATA_COLUMN[gLAST_NAME]},
                { "data":  gDATA_COLUMN[gCOUNTRY]},
                { "data":  gDATA_COLUMN[gSUBJECT]},
                { "data":  gDATA_COLUMN[gCUSTOMER_TYPE]},
                { "data":  gDATA_COLUMN[gREGISTER_STATUS]},
                { "data":  gDATA_COLUMN[gACTION]},
            ],
            columnDefs: [
                {
                    targets: 7,
                    defaultContent: `
                <button class="btn btn-info detail-btn">Chi tiết</button>`
                }
            ]
        })
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        loadRestApi();
        onPageLoading();

    })

    function loadRestApi() {
        $.ajax({
            url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
            type: "GET",
            dataType: 'json',
            async: false,
            success: function (res) {
                console.log(Object.entries(res));
                loadApiToTable(res);
            },
            error: function (error) {
                console.assert(error.responseText)
            }
        })
    }
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {

    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function loadApiToTable(user) {
        var vDataTable = $("#user-table").DataTable();
        vDataTable.clear();
        vDataTable.rows.add(user);
        vDataTable.draw();
    }

    function onDeatailBtnClick(element){
        var vRowClick = $(element).parents("tr");
        var vDataTable = $("#user-table").DataTable();
        var vDataRow = vDataTable.row(vRowClick).data();
        console.log(`Id: ${vDataRow.id}`);
        console.log(`Id: ${vDataRow.firstname}`);
        console.log(`Id: ${vDataRow.lastname}`);
        console.log(`Id: ${vDataRow.country}`);
        console.log(`Id: ${vDataRow.subject}`);
        console.log(`Id: ${vDataRow.customerType}`);
        console.log(`Id: ${vDataRow.registerStatus}`);
    }
</script>

<body>
    <div class="container">
        <h1 class="text-center">Danh sách đăng ký</h1>
        <table id="user-table" class="table table-bordered table-hover table-striped">
            <thead>
                <tr>
                    <th>Mã người dùng</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>

</html>